// The header file defining the node in sparse matrix.
// It could be any type.

#ifndef __NODE_H__
#define __NODE_H__

#include <iostream.h>
// #include "row.h"

//using namespace std;

template <class T>
class node {
private:
    T *val;     // a pointer back to original object
    int rowNum, colNum;
	// row* array; 

public:
    // Constructors and destructor
	node ( const node<T>* n )
    { 
		rowNum = n->rowNumber();
		colNum = n->colNumber();
		val = n->value();
		array = n->array;
	}

	// node ( row* rowPtr, const int row, const int col, const T value )
	node ( const int rowNumber, const int colNumber, const T value )
	{
		// array = rowPtr;
		rowNum = rowNumber;
		colNum = colNumber;
		val = value;
	}

	// promotion constructor - used when saving a pointer to object
	// This is from the code of Dr. Fawcett's sample
	node( const T *tptr ) { val = tptr; }

    node () { array = 0; rowNum = 0; colNum = 0; val = (T) 0; }

	~node() { }

	// assignment - used when writing a T to a proxy
	// This is from the code of Dr. Fawcett's sample
	void operator=(const T &t) 
	{
		if( t != 0 ) {
			*val = t;
		} else {
			// array.remove(this);
			delete this;
		}
	}

	// cast operator - used when reading a T from a proxy
	// This is from the code of Dr. Fawcett's sample
	operator const T() { return *val; }

	// get value and set value
	inline int rowNumber() { return rowNum; }
	inline int colNumber() { return colNum; }
	inline int value() { return colNum; }
};
#endif
